﻿using PWC.Security;
using PWC.SQlite;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace PWC.Migration.cs
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
 
        }

        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            using (OpenFileDialog _dlg = new OpenFileDialog())
            {
                _dlg.Filter = "SQLite Files (*.sqlite)|*.sqlite";
                if (_dlg.ShowDialog() != DialogResult.OK)
                    return;
                txtContainer.Text = _dlg.FileName;
            }
        }

        private void btnMigrate_Click(object sender, EventArgs e)
        {
            migrateContainer();
        }

        private void migrateContainer()
        {
            try
            {
                if (!File.Exists(txtContainer.Text))
                {
                    MessageBox.Show("Container not found.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                SQLiteBase SQL = new SQLiteBase();
                SQL.Open(txtContainer.Text);
                List<string[]> tmpDataRes = new List<string[]>();
                List<string[]> Passwoerter = new List<string[]>();
                List<string[]> Groups = new List<string[]>();
                string tmpMasterPassword;
                string tmpSecurityID;

                string oldDbpw;

                Int32 count = 0;
                Passwoerter = SQL.Query("SELECT * FROM `Passwort`");
                tmpDataRes = SQL.Query("SELECT SecurityID, MasterPasswort FROM `Config`");
                tmpMasterPassword = tmpDataRes[0][1];

                tmpSecurityID = tmpDataRes[0][0];
                tmpDataRes = SQL.Query("SELECT count(*) AS 'ABC' FROM `Passwort`");
                CryptLibrary.Crypt _newCrypter = new CryptLibrary.Crypt();

                if (_newCrypter.MD5StringHash(txtOldPassword.Text) != tmpMasterPassword)
                {
                    MessageBox.Show("Incorrect password.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                else
                {
                    oldDbpw = _newCrypter.MD5StringHash(txtOldPassword.Text);
                    switch (tmpSecurityID)
                    {

                        case "1":
                            oldDbpw = oldDbpw + "35qWwRyZ%";
                            break;
                        case "2":
                            oldDbpw = oldDbpw + "#+#ßß4§13!aAwX";
                            break;
                        case "3":
                            oldDbpw = oldDbpw + "#*+?&%§$3§$y><|;:447956";
                            break;
                        case "4":
                            oldDbpw = oldDbpw + "K3wGAZVikDW%§$3§$Nj0EpKNzRaXkscNl*+?&%§aQcQ|;:44795schw";
                            break;
                    }
                }

                File.Copy(txtContainer.Text, String.Format("{0}.bak", txtContainer.Text), true);

                frmMainProgressBar.Maximum = Convert.ToInt32(tmpDataRes[0][0]);
                frmMainProgressBar.Visible = true;
                lblUpdating.Visible = true;
                Cursor = Cursors.WaitCursor;
                Application.DoEvents();
                CryptLibrary.Crypt crypt = new CryptLibrary.Crypt();
                string csvHeader = "\"Group\",\"Title\",\"Username\",\"Password\",\"URL\",\"Notes\"";
                List<string> list = new List<string>();
                list.Add(csvHeader);
                do
                {
                    Application.DoEvents();
                    frmMainProgressBar.Value = count+1;
                    lblUpdating.Text = String.Format(lblUpdating.Tag.ToString(), count + 1, Convert.ToInt32(tmpDataRes[0][0]));

                    string title = Passwoerter[count][1];
                    string accountName = Passwoerter[count][2];
                    string accountPasswort = crypt.entcrypt(oldDbpw, Passwoerter[count][4]);
                    string accountName2 = Passwoerter[count][3];
                    string accountPasswort2 = crypt.entcrypt(oldDbpw, Passwoerter[count][5]);
                    string accountEMail = Passwoerter[count][6];
                    string accountPage = Passwoerter[count][7];
                    string notes = string.Empty;
                    string accountTag = Passwoerter[count][12];

                    Groups = SQL.Query(
                        $"SELECT GRP_ID, GRP_Name FROM `Groups` WHERE GRP_ID='{Passwoerter[count][11]}'");
                    string grpTmp = Groups[0][1];
                    string grpName = string.IsNullOrWhiteSpace(grpTmp) ? "Default" : grpTmp;

                    string accountInfo = Passwoerter[count][9];
                    string accountOther = Passwoerter[count][8];

                    notes = $"TAGS:{accountTag}INFO:{accountInfo}OTHER:{accountOther}EMAIL:{accountEMail}";

                    list.Add($"\"{grpName}\",\"{title}\",\"{accountName}\",\"{accountPasswort}\",\"{accountPage}\",\"{notes}\"");
                  

                    if (!String.IsNullOrWhiteSpace(accountName2))
                    {
                        list.Add($"\"{grpName}\",\"{title}\",\"{accountName2}\",\"{accountPasswort2}\",\"{accountPage}\",\"{notes}\"");
                    }
                    count++;
                }
                while (Convert.ToInt32(tmpDataRes[0][0]) != count);
                Cursor = Cursors.Default;

                SaveFileDialog saveFileDialog = new SaveFileDialog();
                saveFileDialog.Filter = "csv files (*.csv)|*.csv";
                if (saveFileDialog.ShowDialog() == DialogResult.OK)
                    File.WriteAllLines(saveFileDialog.FileName, list);

                MessageBox.Show("Done!", "Well...", MessageBoxButtons.OK, MessageBoxIcon.Information);
                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("(C) SRV32 und Partner 2018\nWritten by: Oliver Zwar\nWebpage: www.srv32.de", "About", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
